{{!--SPDX-FileCopyrightText: 2024 eclipse foundation --}}
{{!-- SPDX-License-Identifier: EPL-2.0 --}}

{{> copyright }}
apiVersion: v1
kind: ConfigMap
metadata:
  {{> common-metadata }}
  name: {{project.kubeNamespaceName}}-{{ctx}}-cm
data:
  entrypoint: |
    #!/bin/bash
    set -e
    
    [[ "$REGISTER_DEBUG" == "true" ]] && set -x

    mkdir -p /home/gitlab-runner/.gitlab-runner/

    cp /configmaps/config.toml /home/gitlab-runner/.gitlab-runner/

    {{#if runner.runners.kubernetes.sessionServer}}
    quit() {
      kill -TERM "$child"
    }

    trap quit QUIT TERM

    sh /configmaps/set-session-server-address &
    child=$!
    wait "$child"
    {{/if}}

    # Set up environment variables for cache
    if [[ -f /secrets/accesskey && -f /secrets/secretkey ]]; then
      export CACHE_S3_ACCESS_KEY=$(cat /secrets/accesskey)
      export CACHE_S3_SECRET_KEY=$(cat /secrets/secretkey)
    fi

    if [[ -z "${REGISTRATION_TOKEN}" ]] && [[ -f /secrets/runner-registration-token ]]; then
      export REGISTRATION_TOKEN=$(cat /secrets/runner-registration-token)
    fi

    if [[ -z "${CI_SERVER_TOKEN}" ]] && [[ -f /secrets/runner-token ]]; then
      export CI_SERVER_TOKEN=$(cat /secrets/runner-token)
    fi

    # Validate this also at runtime in case the user has set a custom secret
    #if [[ ! -z "$CI_SERVER_TOKEN" && "1" -ne "1" ]]; then
    #  echo "Using a runner token with more than 1 replica is not supported."
    #  exit 1
    #fi

    # Register the runner
    if ! sh /configmaps/register-the-runner; then
      exit 1
    fi

    # Run pre-entrypoint-script
    if ! bash /configmaps/pre-entrypoint-script; then
      exit 1
    fi

    # Start the runner
    exec /entrypoint run --user=gitlab-runner \
      --working-directory=/home/gitlab-runner

  config.toml: |
    concurrent = {{runner.global.concurrent}}
    check_interval = {{runner.global.checkInterval}}

    {{#if runner.global.metricsPort}}
    listen_address = ':{{runner.global.metricsPort}}'
    {{/if}}
    {{#if runner.global.sentryDsn}}
    sentry_dsn = "{{runner.global.sentryDsn}}"
    {{/if}}


    {{#if runner.runners.kubernetes.sessionServer}}
    [session_server]
      session_timeout = {{runner.runners.kubernetes.sessionServer.sessionTimeout}}
      listen_address = "0.0.0.0:{{runner.runners.kubernetes.sessionServer.internalPort}}"
      advertise_address = "SESSION_SERVER_IP:{{ runner.runners.kubernetes.sessionServer.externalPort}}"
    {{/if}}


  config.template.toml:   |

    [[runners]]
      {{!-- see https://gitlab.com/gitlab-org/gitlab-runner/-/issues/259 --}}
      environment = [
        {{#if exportTagListAsEnv}}
{{#taglist tagListPrefix}}{{runner.env.runner.tagList}}{{/taglist}}
        {{/if}}
        {{#each runner.runners.env}}
            "{{@key}}={{{this}}}",
        {{/each}} 
      ]

      [runners.kubernetes]
      {{#if runner.runners.kubernetes.dns_policy}}
        dns_policy = "{{runner.runners.kubernetes.dns_policy}}"
      {{/if}}    

      {{#if runner.runners.kubernetes.dns_config}}
        [runners.kubernetes.dns_config]
            {{#if runner.runners.kubernetes.dns_config.nameservers}}
            nameservers=[              
              {{#each runner.runners.kubernetes.dns_config.nameservers}}"{{{this}}}",{{/each}}  
              ]
            {{/if}}
            {{#if runner.runners.kubernetes.dns_config.searches}}
            searches=[              
              {{#each runner.runners.kubernetes.dns_config.searches}}"{{{this}}}",{{/each}}  
              ]
            {{/if}}
      {{/if}}      

      {{#if runner.runners.kubernetes.nodeSelector}}
        [runners.kubernetes.node_selector]
      {{#each runner.runners.kubernetes.nodeSelector}}
          "{{@key}}"="{{{this}}}"
      {{/each}}      
      {{/if}}      

      {{#if runner.runners.kubernetes.nodeTolerations}}
        [runners.kubernetes.node_tolerations]
      {{#each runner.runners.kubernetes.nodeTolerations}}
          "{{@key}}"="{{{this}}}"
      {{/each}}     
      {{/if}}      

      {{#if runner.runners.kubernetes.podLabels}}
        [runners.kubernetes.pod_labels]
      {{#each runner.runners.kubernetes.podLabels}}
          "{{@key}}"="{{{this}}}"
      {{/each}}      
      {{/if}}      

      {{#if runner.runners.kubernetes.podAnnotations}}
        [runners.kubernetes.pod_annotations]
      {{#each runner.runners.kubernetes.podAnnotations}}
          "{{@key}}"="{{{this}}}"
      {{/each}}
      {{/if}}      

      {{#each runner.runners.kubernetes.volumes.host_path}}
        [[runners.kubernetes.volumes.host_path]]
          name = "{{name}}"
          mount_path = "{{mount_path}}"
          read_only = {{read_only}}
          host_path = "{{host_path}}" 
      {{/each}}
      {{#each runner.runners.kubernetes.volumes.pvc}}
        [[runners.kubernetes.volumes.pvc]]
          name = "{{name}}"
          mount_path = "{{mount_path}}"
          {{#if this.sub_path}}
          sub_path = "{{sub_path}}"
          {{/if}}
          {{#if this.read_only}}
          read_only = {{read_only}}
          {{/if}}
          {{#if this.mount_propagation}}
          mount_propagation = "{{mount_propagation}}"
          {{else}}
          mount_propagation = "None"
          {{/if}}
      {{/each}}
      {{#each runner.runners.kubernetes.volumes.empty_dir}}
        [[runners.kubernetes.volumes.empty_dir]]
          name = "{{name}}"
          mount_path = "{{mount_path}}"
          medium = "{{medium}}"
      {{/each}}
      {{#each runner.runners.kubernetes.volumes.configmap}}
        [[runners.kubernetes.volumes.configmap]]
          name = "{{name}}"
          mount_path = "{{mount_path}}""
          {{#if this.read_only}}
          read_only = {{read_only}}
          {{/if}}
          {{#if this.sub_path}}
          sub_path = "{{sub_path}}"
          {{/if}}
          {{#if this.items}}
          [runners.kubernetes.volumes.config_map.items]
            {{#each items}}
            "{{@key}}"="{{{this}}}"
            {{/each}}
          {{/if}}
      {{/each}}

      {{#if runner.runners.kubernetes.volumes.secret}}
        [[runners.kubernetes.volumes.secret]]
      {{#each runner.runners.kubernetes.volumes.secret}}
          name = "{{name}}"
          mount_path = "{{mount_path}}"
          read_only = true
          {{#if this.sub_path}}
          sub_path = "{{sub_path}}"
          {{/if}}
          {{#if this.items}}
          [runners.kubernetes.volumes.secret.items]
            {{#each items}}
            "{{@key}}"="{{{this}}}"
            {{/each}}
          {{/if}}
      {{/each}}
      {{/if}}

  register-the-runner: |
    #!/bin/bash

    [[ "$REGISTER_DEBUG" == "true" ]] && set -x
    MAX_REGISTER_ATTEMPTS=30

    for i in $(seq 1 "${MAX_REGISTER_ATTEMPTS}"); do
      echo "Registration attempt ${i} of ${MAX_REGISTER_ATTEMPTS}"
      /entrypoint register --non-interactive &
      
      register_pid=$!
      wait $register_pid
      retval=$?

      if [ ${retval} = 0 ]; then
        break
      elif [ ${i} = ${MAX_REGISTER_ATTEMPTS} ]; then
        exit 1
      fi

      sleep 5
    done

    exit 0

  check-live: |
    #!/bin/bash
    set -eou pipefail

    # default timeout is 3 seconds, can be overriden
    VERIFY_TIMEOUT=${1:-${VERIFY_TIMEOUT:-3}}

    if ! /usr/bin/pgrep -f ".*register-the-runner"  > /dev/null && ! /usr/bin/pgrep -f "gitlab.*runner"  > /dev/null ; then
      exit 1
    fi

    status=0
    # empty --url= helps `gitlab-runner verify` select all configured runners (otherwise filters for $CI_SERVER_URL)
    verify_output=$(timeout "${VERIFY_TIMEOUT}" gitlab-runner verify --url= 2>&1) || status=$?

    # timeout exit code is 143 with busybox, and 124 with coreutils
    if (( status == 143 )) || (( status == 124 )) ; then
      echo "'gitlab-runner verify' terminated by timeout, not a conclusive failure" >&2
      exit 0
    elif (( status > 0 )) ; then
      exit ${status}
    fi

    grep -qE "is (alive|valid)" <<<"${verify_output}"

  {{#if runner.runners.kubernetes.sessionServer}}
  set-session-server-address: |
    #!/bin/bash
    APISERVER=https://kubernetes.default.svc \
      && SERVICEACCOUNT=/var/run/secrets/kubernetes.io/serviceaccount \
      && NAMESPACE=$(cat ${SERVICEACCOUNT}/namespace) \
      && TOKEN=$(cat ${SERVICEACCOUNT}/token) \
      && CACERT=${SERVICEACCOUNT}/ca.crt \
      && header="Authorization: Bearer ${TOKEN}"

    SERVICEURL=${APISERVER}/api/v1/namespaces/${NAMESPACE}/services/{{project.kubeNamespaceName}}-3s

    has_address=false
    while [ "${has_address}" = false ]; do
      SERVICEIP=$(curl —-silent \
        --cacert ${CACERT} \
        --header "${header}" \
        -X GET ${SERVICEURL} 2>/dev/null \
        | grep '"ip":' | cut -d ":" -f2 | xargs)

      # for aws, the hostname is available but not the external IP
      SERVICEHOSTNAME=$(curl —-silent \
        --cacert ${CACERT} \
        --header "${header}" \
        -X GET ${SERVICEURL} 2>/dev/null \
        | grep '"hostname":' | cut -d ":" -f2 | xargs)

      ADDRESS="${SERVICEHOSTNAME:-$SERVICEIP}"
      
      if [ -z "${ADDRESS}" ]
      then
        echo "Service LoadBalancer External Address not yet available"
        has_address=false
        sleep 5
      else
        has_address=true
        sed -i -e "s/SESSION_SERVER_IP/${ADDRESS}/g" /home/gitlab-runner/.gitlab-runner/config.toml
      fi
    done
  {{/if}} 

  pre-entrypoint-script: |
